//----------------------------------------------------------------------------
//  EDGE Floor and Ceiling Rendering Code
//----------------------------------------------------------------------------
// 
//  Copyright (c) 1999-2000  The EDGE Team.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//----------------------------------------------------------------------------
//
//  Based on the DOOM source code, released by Id Software under the
//  following copyright:
//
//    Copyright (C) 1993-1996 by id Software, Inc.
//
//----------------------------------------------------------------------------
//
// -KM- 1998/09/27 Dynamic colourmaps
//

#ifndef __R_PLANE__
#define __R_PLANE__

#include "r_data.h"
#include "m_math.h"
#include "z_zone.h"

// Visplane related.
extern int lastopening;
extern stack_array_t openings_a;
extern short *openings;

extern short *floorclip;
extern short *ceilingclip;

extern short *extra_F_clip;  // -AJA- 1999/08/16.

extern short *extra_C_clip;  //

// -ES- 1999/03/20 Removed origyslope
extern float_t *yslope;
extern float_t *distscale;

// -ES- 1999/05/26 Externalised these.
extern int *spanstart;

void R_InitPlanes(void);
void R_ClearPlanes(void);

void R_MapPlane(int y, int x1, int x2);
void R_MakeSpans(int x, int t1, int b1, int t2, int b2);

void R_DrawSinglePlane(visplane_t * pl);
void R_DrawPlanes(void);

visplane_t *R_FindPlane(plane_info_t *info, 
    region_properties_t *props, int flags);

visplane_t *R_CheckPlane(visplane_t * pl, int start, int stop);

#endif
