//----------------------------------------------------------------------------
//  EDGE Video Code for 16-Bit Colour. 
//----------------------------------------------------------------------------
// 
//  Copyright (c) 1999-2000  The EDGE Team.
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//----------------------------------------------------------------------------
//
//  Based on the DOOM source code, released by Id Software under the
//  following copyright:
//
//    Copyright (C) 1993-1996 by id Software, Inc.
//
//----------------------------------------------------------------------------

#ifndef __V_VIDEO2__
#define __V_VIDEO2__
#ifndef NOHICOLOUR

#include "dm_type.h"
#include "dm_defs.h"

// Needed because we are refering to patches.
#include "r_data.h"
#include "v_screen.h"

// Allocates buffer screens, call before R_Init.
void V_Init16(void);

void V_CopyRect16(screen_t * dest, screen_t * src, int srcx, int srcy, int width, int height, int destx, int desty);

void V_CopyScreen16(screen_t * dest, screen_t * src);

void V_DrawPatch16(screen_t * scr, int x, int y, const patch_t * patch);

void V_DrawPatchFlipped16(screen_t * scr, int x, int y, const patch_t * patch);

void V_DrawPatchDirect16(screen_t * scr, int x, int y, const patch_t * patch);

//stretches bitmap to full screen
void V_DrawPatchInDirect16(screen_t * scr, int x, int y, const patch_t * patch);

void V_DrawPatchInDirectFlipped16(screen_t * scr, int x, int y, const patch_t * patch);

void V_DrawPatchTrans16(screen_t * scr, int x, int y, const byte *trans, const patch_t * patch);

void V_DrawPatchInDirectTrans16(screen_t * scr, int x, int y, const byte *trans, const patch_t * patch);

void V_DrawPatchShrink16(screen_t * scr, int x, int y, const patch_t * patch);

// Draw a linear block of pixels into the view buffer.
void V_DrawBlock16(screen_t * dest, int x, int y, int width, int height, byte * src);

// Reads a linear block of pixels into the view buffer.
void V_GetBlock16(screen_t * scr, int x, int y, int width, int height, byte * dest);

void V_MarkRect16(int x, int y, int width, int height);

void V_DarkenScreen16(screen_t * scr);

// 98-7-10 KM Reduce code redundancy
void V_TextureBackScreen16(screen_t * scr, const char *flatname, int left, int top, int right, int bottom);

// -AJA- 1999/07/04: added the following misc drawing functions:
void V_DrawPixel16(screen_t * scr, int x, int y, int c);
void V_DrawLine16(screen_t * scr, int x1, int y1, int x2, int y2, int c);
void V_DrawBox16(screen_t * scr, int x, int y, int w, int h, int c);

void V_DrawPatchClip16(screen_t * scr, int x, int y, int left, int top, int right, int bottom, boolean_t flip, const patch_t * patch);

#endif // NOHICOLOUR
#endif // __V_VIDEO2__
